(document:surround "/std/base")
(document:insert "/std/functions")

(document:envelop with-translation _ "alterator-@module@")

(gridbox columns "20;40;60;20"
	 ;;
	 (spacer)
	 (label (_ "Hello World!"))
	 (document:id hello-world (edit ""
					widget-name "hello-world"
					tooltip (_ "Text should match ^[[:alnum:]]+$")))
	 (spacer)
	 ;;
	 (spacer)
	 (label (_ "Oh Really?"))
	 (document:id check-it (checkbox "" widget-name "check-it"))
	 (spacer))

(gridbox columns "30;30;30"
	 align "center"
	 (document:id apply-button (button (_ "Apply")))
	 (document:id reset-button (button (_ "Reset")))
	 (document:id quit-button  (button (_ "Quit"))))

;;;;;;;;;;;;;;;;;;;;;; backend communication
;;; read our config file
(define (read-me)
  (let ((data (woo-read-first "/@module@" )))
    (hello-world text (woo-get-option data 'hello))
    (check-it state (woo-get-option data 'check))))

;;; write back something
(define (write-me)
  (woo-catch/message
    (thunk
      (woo-write/constraints "/@module@"
			     'hello (hello-world text)
			     'check (check-it state)))))

;;;;;;;;;;;;;;;;;;;;;; button handlers
(apply-button (when clicked
		(write-me)
		(read-me)))

(reset-button (when clicked (read-me)))

(quit-button (when clicked (document:end)))

;;;;;;;;;;;;;;;;;;;;;; initialization
(document:root
  (when loaded (read-me)))
